
# If this next line of code fails..
# http://www.imitationpickles.org/pgu/wiki/index
from pgu import gui

from mediator import Event, mediator
import turn
import spinny_arrow

class MyTable(gui.Table):
    def __init__(self, **params):
        gui.Table.__init__(self, **params)

        self.tr()
        start = gui.Button('Start Game', name='start')
        self.td(start)
        start.connect(gui.CLICK, mediator.publishEvent, Event("start_game"))
        
        self.tr()
        wtf = gui.Button('WTF? (help)', name='wtf')
        self.td(wtf)
        wtf.connect(gui.CLICK, mediator.publishEvent, Event("wtf"))
        
        self.tr()
        quit = gui.Button('Quit Wind Gods', name='quit')
        self.td(quit)
        quit.connect(gui.CLICK, mediator.publishEvent, Event("quit_game"))
        
            
class StartMenu(object):
    def __init__(self):
        self.displaying_menu = False
        
    def initialize(self, display=False):
        self.c = gui.Container(align=-1, valign=-1)
        self.my_table = MyTable()

        if display:
            self.displayMenu()

    def displayMenu(self):
        if not self.displaying_menu:
            print "displaying StartMenu"
            self.c.add(self.my_table, 0, 0)
            app.init(self.c)
            self.displaying_menu = True
        
    def undisplayMenu(self):
        if self.displaying_menu:
            self.c.remove(self.my_table)
            self.displaying_menu = False


class InGameTable(gui.Table):
    def __init__(self, **params):
        gui.Table.__init__(self, **params)
        
        self.tr()
        wtf = gui.Button("Done my turn", name='next_turn')
        self.td(wtf)
        wtf.connect(gui.CLICK, mediator.publishEvent, Event("next_turn"))
        
        self.tr()
        quit = gui.Button('Quit game', name='game_over')
        self.td(quit)
        quit.connect(gui.CLICK, mediator.publishEvent,
            Event("game_over", winner=None))

class InGameMenu(object):
    def __init__(self):
        self.displaying_menu = False
        
    def initialize(self, display=False):
        self.c = gui.Container(align=-1, valign=-1)
        self.my_table = InGameTable()

        if display:
            self.displayMenu()
        
    def displayMenu(self):
        if not self.displaying_menu:
            print "displaying InGameMenu"
            self.c.add(self.my_table, 0, 0)
            app.init(self.c)
            self.displaying_menu = True
        
    def undisplayMenu(self):
        if self.displaying_menu:
            self.c.remove(self.my_table)
            self.displaying_menu = False


class PlanAttackTable(gui.Table):
    def __init__(self, **params):
        gui.Table.__init__(self, **params)

        self.tr()
        start = gui.Button('Done my turn', name='plan_attack_done_turn')
        self.td(start)
        start.connect(gui.CLICK, mediator.publishEvent, Event("plan_attack_done_turn"))

        self.tr()
        add_tornado = gui.Button('Add Tornado', name='plan_attack_add_tornado')
        self.td(add_tornado)
        add_tornado.connect(gui.CLICK, mediator.publishEvent, Event("plan_attack_add_tornado"))
        
        self.tr()
        quit = gui.Button('Quit game', name='game_over')
        self.td(quit)
        quit.connect(gui.CLICK, mediator.publishEvent, Event("game_over", winner=None))

class PlanAttackTable_Done(gui.Table):
    def __init__(self, **params):
        gui.Table.__init__(self, **params)

        self.tr()
        start = gui.Button('Done my turn', name='plan_attack_done_turn')
        self.td(start)
        start.connect(gui.CLICK, mediator.publishEvent, Event("plan_attack_done_turn"))

        self.tr()
        quit = gui.Button('Quit game', name='game_over')
        self.td(quit)
        quit.connect(gui.CLICK, mediator.publishEvent, Event("game_over", winner=None))
        
class PlanAttackMenu(object):
    def __init__(self):
        self.displaying_menu = False
        
    def initialize(self, display=False):
        self.c = gui.Container(align=-1, valign=-1)
        self.my_table = PlanAttackTable()

        if display:
            self.displayMenu()
        
    def displayMenu(self):
        if not self.displaying_menu:
            print "displaying PlanAttackMenu"
            self.c.add(self.my_table, 0, 0)
            app.init(self.c)
            self.displaying_menu = True
        
    def undisplayMenu(self):
        if self.displaying_menu:
            self.c.remove(self.my_table)
            self.displaying_menu = False

class PlanAttackMenu_Done(object):
    def __init__(self):
        self.displaying_menu = False
        
    def initialize(self, display=False):
        self.c = gui.Container(align=-1, valign=-1)
        self.my_table = PlanAttackTable_Done()

        if display:
            self.displayMenu()
        
    def displayMenu(self):
        if not self.displaying_menu:
            print "displaying PlanAttackMenu_Done"
            self.c.add(self.my_table, 0, 0)
            app.init(self.c)
            self.displaying_menu = True
        
    def undisplayMenu(self):
        if self.displaying_menu:
            self.c.remove(self.my_table)
            self.displaying_menu = False

class PlanAttack_MoveResizeTable(gui.Table):
    def __init__(self, **params):
        gui.Table.__init__(self, **params)

        self.tr()
        add_tornado = gui.Button('Done Moving/Resizing tornado', name='plan_attack_move_resize')
        self.td(add_tornado)
        add_tornado.connect(gui.CLICK, mediator.publishEvent, Event("plan_attack_move_resize"))

        self.tr()
        add_tornado = gui.Button('Cancel', name='plan_attack_move_cancel')
        self.td(add_tornado)
        add_tornado.connect(gui.CLICK, mediator.publishEvent, Event("plan_attack_move_cancel"))
        
        self.tr()
        quit = gui.Button('Quit game', name='game_over')
        self.td(quit)
        quit.connect(gui.CLICK, mediator.publishEvent, Event("game_over", winner=None))
        
class PlanAttack_MoveResizeMenu(object):
    def __init__(self):
        self.displaying_menu = False
        
    def initialize(self, display=False):
        self.c = gui.Container(align=-1, valign=-1)
        self.my_table = PlanAttack_MoveResizeTable()

        if display:
            self.displayMenu()
        
    def displayMenu(self):
        if not self.displaying_menu:
            print "displaying PlanAttack_MoveResizeMenu"
            self.c.add(self.my_table, 0, 0)
            app.init(self.c)
            self.displaying_menu = True
        
    def undisplayMenu(self):
        if self.displaying_menu:
            self.c.remove(self.my_table)
            self.displaying_menu = False

class AttackTable(gui.Table):
    def __init__(self, **params):
        gui.Table.__init__(self, **params)

        self.tr()
        quit = gui.Button('Quit game', name='game_over')
        self.td(quit)
        quit.connect(gui.CLICK, mediator.publishEvent, Event("game_over", winner=None))
        
class AttackMenu(object):
    def __init__(self):
        self.displaying_menu = False
        
    def initialize(self, display=False):
        self.c = gui.Container(align=-1, valign=-1)
        self.my_table = AttackTable()

        if display:
            self.displayMenu()
        
    def displayMenu(self):
        if not self.displaying_menu:
            print "displaying Attack_Menu"
            self.c.add(self.my_table, 0, 0)
            app.init(self.c)
            self.displaying_menu = True
        
    def undisplayMenu(self):
        if self.displaying_menu:
            self.c.remove(self.my_table)
            self.displaying_menu = False


start_menu = StartMenu()
in_game_menu = InGameMenu()
plan_attack_menu = PlanAttackMenu()
plan_attack_menu_done = PlanAttackMenu_Done()
plan_attack_move_resize_menu = PlanAttack_MoveResizeMenu()
attack_menu = AttackMenu()

def undisplayAllMenus():
    start_menu.undisplayMenu()
    in_game_menu.undisplayMenu()
    plan_attack_menu.undisplayMenu()
    plan_attack_menu_done.undisplayMenu()
    plan_attack_move_resize_menu.undisplayMenu()
    attack_menu.undisplayMenu()


def initialize():
    global form, app
    form = gui.Form()
    app = gui.App()
    start_menu.initialize(display=True)
    in_game_menu.initialize(display=False)
    plan_attack_menu.initialize(display=False)
    plan_attack_menu_done.initialize(display=False)
    plan_attack_move_resize_menu.initialize(display=False)
    attack_menu.initialize(display=False)
    return app, form

