
import os
import pygame

from mediator import mediator

class SoundBank(dict):
    def get(self, key, default=None):
        if (not self.has_key(key)):
            self[key] = pygame.mixer.Sound(os.path.join('data','sound',key))
        return dict.get(self, key, default)

soundBank = None  # only init if we have mixer

class SoundRepeater(object):
    channel = None
    def __init__(self, soundName):
        self.soundName = soundName
    
    def start(self, evt):
        if (not self.channel):
            self.channel = soundBank.get(self.soundName).play(-1)
    
    def stop(self, evt):
        if (self.channel):
            self.channel.stop()
            self.channel = None
            
def soundEvtHandler(soundToPlay):
    def playSoundHandler(evt):
        soundBank.get(soundToPlay).play()
    return playSoundHandler

if (pygame.mixer):
    soundBank = SoundBank()
    
    for e in ('start_game', 'wtf', 'plan_attack_done_turn',
              'plan_attack_add_tornado','plan_attack_move_resize',
              'plan_attack_move_cancel', 'game_over'):
        mediator.addListener(e, soundEvtHandler('fourtone.wav'))

    mediator.addListener('quit_game', soundEvtHandler('endgame.wav'))
    mediator.addListener('hut_died', soundEvtHandler('explosion6.wav'))
    
    sr = SoundRepeater('bop.wav')
    mediator.addListener('tf_start_alter', sr.start)
    mediator.addListener('tf_end_alter', sr.stop)

if __name__=='__main__':
    pygame.mixer.init(44100)
    sr.start(None)
    pygame.time.delay(5000)
    sr.stop(None)
    pygame.time.delay(5000)
